/*--------------------------------------------------------------*\
		module	:	EdLinE.c
		purpose :	PsҏW
		author	:	_@ Kengo Jinno
		create	:	1998/11/11
		update	:	1999/03/01
					2001/02/07	__argvgȂ
					2001/02/07	DDET[rX̃Xg
					2001/02/07	VXej[ɒǉ
					2001/02/07	ENbNŃ|bvAbvj[
					2001/02/07	ACR쐬Eǉ
					2001/02/07	GlobalReAlloc()GMEM_MOVEABLEǉ
					2001/02/07	ShowWindow( hWnd, SW_SHOWDEFAULT );
								g
					2001/04/20	Í͈ELbg荶
								oł悤ɂ
					2001/04/20	ҏWsRichEditɂł悤ɂ
					2001/04/23	c[`bvǉ
					2001/11/19	}EX֌W̃bZ[W̍ẂA
								shortɃLXgB
					2001/11/19	CreateTooltip()̈ǉɑΉ
					2001/11/19	bZ[W[vRelayEventTooltip()
								Ă
					2014/04/04	ESCőSď@\ǉ
					2014/04/10	RichEdit̎TABŐݒ{^Ȃ
								̂C
\*--------------------------------------------------------------*/

#include	"PCH.h"
#include	"EdLinE.h"
#include	"ConfigDg.h"
#include	"MyDDE.h"
#ifdef	WIN32
#include	"Tooltip.h"
#endif

#if ( WINVER < 0x030a )
#include	<jctype.h>
#endif

#ifdef	WIN32
#define		VERSION		_T("1.4(32)")
#else
#define		VERSION		_T("1.4(16)")
#endif

#define	ICON_APPLICATION

const	TCHAR	BASED_CODE	szEdLineWndClass[] = _T("EdLinEWndClass");	/*	EBhENX	*/
const	TCHAR	BASED_CODE	szEdLineAppName[] = _T("EdLinE");			/*	LvV		*/

static	const	TCHAR	BASED_CODE	lpszProfileSection[] = _T("EdLinE");
static	const	TCHAR	BASED_CODE	lpszProfileEntry[] = _T("Version");
static	const	TCHAR	BASED_CODE	lpszProfileEditSendSection[] = _T("EditSend");
static	const	TCHAR	BASED_CODE	lpszProfileConfigSection[] = _T("Config");
static	const	TCHAR	BASED_CODE	lpszProfileShiftLock[] = _T("ShiftLock");
static	const	TCHAR	BASED_CODE	lpszProfileRtdDde[] = _T("RtdDde");
static	const	TCHAR	BASED_CODE	lpszProfileDdeServer[] = _T("DdeServiceName");
static	const	TCHAR	BASED_CODE	lpszProfileDdeList[] = _T("DdeServiceList");
static	const	TCHAR	BASED_CODE	lpszProfileSendAll[] = _T("SendAll");
#ifdef	WIN32
static	const	TCHAR	BASED_CODE	lpszProfileRichEdit[] = _T("RichEdit");
static	const	TCHAR	BASED_CODE	lpszProfileBalloonTip[] = _T("BalloonTip");
#endif
static	const	TCHAR	BASED_CODE	lpszProfileClearAll[] = _T("ClearAllByEsc");
static	const	TCHAR	BASED_CODE	lpszProfileFontSection[] = _T("Font");
static	const	TCHAR	BASED_CODE	lpszProfileHeightEntry[] = _T("Height");
static	const	TCHAR	BASED_CODE	lpszProfileWeightEntry[] = _T("Weight");
static	const	TCHAR	BASED_CODE	lpszProfileItalicEntry[] = _T("Italic");
static	const	TCHAR	BASED_CODE	lpszProfileUnderlineEntry[] = _T("Underline");
static	const	TCHAR	BASED_CODE	lpszProfileCharSetEntry[] = _T("ChaSet");
static	const	TCHAR	BASED_CODE	lpszProfilePitchAndFamilyEntry[] = _T("PitchAndFamily");
static	const	TCHAR	BASED_CODE	lpszProfileFaceNameEntry[] = _T("FaceName");

BOOL	NEAR	ClientToScreenRect( HWND hWnd, LPRECT lprect )
{
	POINT	p;
	p.x = lprect->left;
	p.y = lprect->top;
#ifdef	WIN32
	if( !ClientToScreen( hWnd, &p ) ) {
		return FALSE;
	}
#else
	ClientToScreen( hWnd, &p );
#endif
	lprect->left = p.x;
	lprect->top = p.y;
	p.x = lprect->right;
	p.y = lprect->bottom;
#ifdef	WIN32
	if( !ClientToScreen( hWnd, &p ) ) {
		return FALSE;
	}
#else
	ClientToScreen( hWnd, &p );
#endif
	lprect->right = p.x;
	lprect->bottom = p.y;
	return TRUE;
}

BOOL	NEAR	ScreenToClientRect( HWND hWnd, LPRECT lprect )
{
	POINT	p;
	p.x = lprect->left;
	p.y = lprect->top;
#ifdef	WIN32
	if( !ScreenToClient( hWnd, &p ) ) {
		return FALSE;
	}
#else
	ScreenToClient( hWnd, &p );
#endif
	lprect->left = p.x;
	lprect->top = p.y;
	p.x = lprect->right;
	p.y = lprect->bottom;
#ifdef	WIN32
	if( !ScreenToClient( hWnd, &p ) ) {
		return FALSE;
	}
#else
	ScreenToClient( hWnd, &p );
#endif
	lprect->right = p.x;
	lprect->bottom = p.y;
	return TRUE;
}


#define	SPACE	4	/*	Rg[̗̎](dot)	*/

/*	TCYύXɔāARg[̈ʒu傫vZȂ	*/
void	NEAR	RecalcLayout( HWND hWnd )
{
	NpEdLineInfo	p = GetEdLineInfo( hWnd );
	RECT	rectWindowOrg, rectClientOrg;		/*	EdLinẼEBhE	*/
	RECT	rectWindowEdit, rectClientEdit;		/*	GfBbg{bNX̃EBhE	*/
	RECT	rectWindowButton, rectClientButton;	/*	ݒ{^̃EBhE	*/
	int		nHeight;
	
	if( p == NULL ) {
		return;
	}
	if( IsIconic( hWnd ) ) {
		return;
	}
	
	/*	݂̃EBhEENCAgW(XN[W)	*/
	GetWindowRect( hWnd, &rectWindowOrg );
	GetClientRect( hWnd, &rectClientOrg );
	
	/*	GfBbg{bNX	*/
	/*	͕鍂A͂ł͕ۗ	*/
	GetWindowRect( p->hWndEdit, &rectWindowEdit );
	GetClientRect( p->hWndEdit, &rectClientEdit );
	ScreenToClientRect( hWnd, &rectWindowEdit );
	OffsetRect( &rectWindowEdit, SPACE-rectWindowEdit.left, SPACE-rectWindowEdit.top );
	{	/*	GfBbg{bNX̍vZ	*/
		HDC		hdc;
		RECT	rect;
		SendMessage( p->hWndEdit, EM_GETRECT, 0, (LPARAM)&rect );	/*	``	*/
		hdc = GetDC( p->hWndEdit );
		if( hdc != NULL ) {
			TEXTMETRIC	tm;
			HFONT	hOldFont;
			hOldFont = SelectObject( hdc, p->hFont );
			GetTextMetrics( hdc, &tm );
			nHeight = tm.tmHeight + tm.tmExternalLeading;
#ifdef	WIN32
			if( !p->bRichEdit ) {
#endif
				/*	RichEditłƁAǂǂ傫ȂĂ܂	*/
				nHeight = ( nHeight > rect.bottom-rect.top ) ? nHeight : rect.bottom-rect.top;
#ifdef	WIN32
			}
#endif
			nHeight += 2*rect.left;		/*	̏㉺̋󔒕␳	*/
			/*	(rect.toṕATCYEditBox傫Ƀ[ɂȂ̂ŁAleftg)	*/
			SelectObject( hdc, hOldFont );
			ReleaseDC( p->hWndEdit, hdc );
		} else {
			nHeight = p->lfText.lfHeight;
			nHeight = ( nHeight > 0 ) ? nHeight : -nHeight;
			nHeight = (int)( ( (long)nHeight * 120L ) / 100L );
		}
	}
	rectWindowEdit.bottom = rectWindowEdit.top + nHeight + ( rectWindowEdit.bottom - rectWindowEdit.top ) - ( rectClientEdit.bottom - rectClientEdit.top );
	
	/*	ݒ{^	*/
	/*	͐XN[o[̖̕	*/
	/*	E[܂Ŋ񂹂	*/
	GetWindowRect( p->hWndButton, &rectWindowButton );
	GetClientRect( p->hWndButton, &rectClientButton );
	ScreenToClientRect( hWnd, &rectWindowButton );
	rectWindowButton.right = rectWindowButton.left + GetSystemMetrics( SM_CXVSCROLL );
	OffsetRect( &rectWindowButton, rectClientOrg.right-SPACE-rectWindowButton.right, SPACE-rectWindowButton.top );
	
	/*	GfBbg{bNX̉E[{^܂Ŋ񂹂	*/
	rectWindowEdit.right = rectWindowButton.left - SPACE;
	/*	ݒ{^̍GfBbg{bNXɍ킹	*/
	rectWindowButton.bottom = rectWindowEdit.bottom;
	
	rectWindowOrg.bottom = rectWindowOrg.top + (2*SPACE+rectWindowEdit.bottom-rectWindowEdit.top) + ( rectWindowOrg.bottom - rectWindowOrg.top ) - ( rectClientOrg.bottom - rectClientOrg.top );
	p->nHeight = rectWindowOrg.bottom - rectWindowOrg.top;
	
	/*	肵ʒu܂ňړETCYύX	*/
	MoveWindow( p->hWndEdit, rectWindowEdit.left, rectWindowEdit.top, rectWindowEdit.right - rectWindowEdit.left, rectWindowEdit.bottom - rectWindowEdit.top, TRUE );
	MoveWindow( p->hWndButton, rectWindowButton.left, rectWindowButton.top, rectWindowButton.right - rectWindowButton.left, rectWindowButton.bottom - rectWindowButton.top, TRUE );
	MoveWindow( hWnd, rectWindowOrg.left, rectWindowOrg.top, rectWindowOrg.right - rectWindowOrg.left, rectWindowOrg.bottom - rectWindowOrg.top, TRUE );
}

/*	GfBbgRg[̃TuNXEBhEvV[W	*/
LRESULT	CALLBACK	EditWndProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	HWND	hWndParent = GetParent( hWnd );
	NpEdLineInfo	p = GetEdLineInfo( hWndParent );
	WNDPROC		lpfnOldWndProc = p->lpfnOldWndProc;
	if( uMsg == WM_CHAR ) {
		LPTSTR	lpszText;
		if( wParam == VK_RETURN ) {
			int		nLen;
			DWORD	dwSize;
			static	const	TCHAR	BASED_CODE	szNewLine[] = _T("\x0d\x0a");
			static	const	TCHAR	BASED_CODE	szClear[] = _T("");
			if( p->bShiftLock && !( (WORD)GetKeyState( VK_SHIFT ) & 0xff00 ) ) {
				return 0L;
			}
			nLen = GetWindowTextLength( hWnd );
			dwSize = sizeof(TCHAR)*(nLen+2+1);	//	\r\n+2byte
			if( dwSize > p->dwSendBuffSize ) {
				p->hSendBuff = GlobalReAlloc( p->hSendBuff, dwSize, GMEM_ZEROINIT|GMEM_MOVEABLE );
				p->dwSendBuffSize = dwSize;
			}
			lpszText = (LPTSTR)GlobalLock( p->hSendBuff );
			GetWindowText( hWnd, lpszText, nLen+1 );
			if( p->bSendAll ) {
				lstrcat( lpszText, szNewLine );
				if( p->bRtdDde ) {
					SendDDEString( hWndParent, lpszText );	/*	M(RTDDDE)	*/
				} else {
					p->lpEdsSendString( lpszText );			/*	M(EditSend)	*/
				}
				SetWindowText( hWnd, szClear );
			} else {
				DWORD	dwSel = SendMessage( hWnd, EM_GETSEL, (WPARAM)NULL, (LPARAM)NULL );
				int		nSt = LOWORD( dwSel );
				int		nEn = HIWORD( dwSel );
				LPTSTR	lpszSend;
				if( nSt != nEn ) {
					/*	IĂ͈	*/
					lpszSend = lpszText + nSt;
					dwSize = nEn - nSt;
				} else {
					/*	Lbg荶	*/
					lpszSend = lpszText;
					dwSize = nSt;
				}
				lpszText[nEn+0] = CR;
				lpszText[nEn+1] = LF;
				lpszText[nEn+2] = _T('\0');
				if( p->bRtdDde ) {
					SendDDEString( hWndParent, lpszSend );	/*	M(RTDDDE)	*/
				} else {
					p->lpEdsSendString( lpszSend );			/*	M(EditSend)	*/
				}
				/*	c̕Đݒ	*/
				GetWindowText( hWnd, lpszText, nLen+1 );
				if( nSt != nEn ) {
					MoveMemory( lpszText + nSt, lpszText + nEn, nLen - nEn + 1 );
				} else {
					MoveMemory( lpszText, lpszText + nSt, nLen - nEn + 1 );
				}
				SetWindowText( hWnd, lpszText );
			}
			GlobalUnlock( p->hSendBuff );
#ifndef	WIN32
			if( !p->bRtdDde && p->hWndTarget != NULL && IsWindow( p->hWndTarget ) ) {
				PostMessage( p->hWndTarget, WM_PAINT, 0, 0 );
			}
			{
				HGLOBAL	handle = GlobalAlloc( GMEM_MOVEABLE|GMEM_SHARE|GMEM_ZEROINIT, sizeof(IMESTRUCT) );
				LPIMESTRUCT	pImeStruct = (LPIMESTRUCT)GlobalLock( handle );
				pImeStruct->fnc = IME_SETCONVERSIONFONT;
				pImeStruct->wParam = (WPARAM)p->hFont;
				GlobalUnlock( handle );
				SendIMEMessage( hWnd, MAKELPARAM( handle, 0 ) );
				GlobalFree( handle );
			}
#endif
			return 0L;
		}
#ifdef	WIN32
	} else if( uMsg == WM_SETFONT && p->bRichEdit ) {
		LRESULT		ret = CallWindowProc( lpfnOldWndProc, hWnd, uMsg, wParam, lParam );
		COLORREF	colText, colBack;
		CHARFORMAT	cfm;
		COMPCOLOR	cc[4];
		
		colText = GetSysColor( COLOR_WINDOWTEXT );
		colBack = GetSysColor( COLOR_WINDOW );
		/*	F	*/
		ZeroMemory( &cfm, sizeof(cfm) );
		cfm.cbSize = sizeof(cfm);
		cfm.dwMask = CFM_COLOR;
		cfm.crTextColor = colText;
		SendMessage( hWnd, EM_SETCHARFORMAT, 0, (LPARAM)&cfm );
		/*	wiF	*/
		SendMessage( hWnd, EM_SETBKGNDCOLOR, 0, (LPARAM)colBack );
		/*	ϊ̐F	*/
		cc[0].crText = cc[2].crText = colText;
		cc[0].crBackground = cc[2].crBackground = colBack;
		cc[0].dwEffects = cc[2].dwEffects = CFE_UNDERLINE;
		cc[1].crText = cc[3].crText = colBack;
		cc[1].crBackground = cc[3].crBackground = colText;
		cc[1].dwEffects = cc[3].dwEffects = 0;
		SendMessage( hWnd, EM_SETIMECOLOR, 0, (LPARAM)cc );
		return ret;
	} else if( uMsg == WM_GETDLGCODE && p->bRichEdit ) {
		LRESULT	ret = CallWindowProc( lpfnOldWndProc, hWnd, uMsg, wParam, lParam );
		return( ret & ~DLGC_WANTTAB );
		/*
			DLGC_WANTTABOȂƁATABĂݒ{^ɃtH[JXړĂȂB
		*/
#endif
	}
	return CallWindowProc( lpfnOldWndProc, hWnd, uMsg, wParam, lParam );
}

/*	INIt@C̓ǂݍ	*/
void	NEAR	ReadProfile( NpEdLineInfo p, LPCTSTR lpszFile )
{
	static	const	TCHAR	BASED_CODE	szDefaultServer[] = _T("RTD");
	static	const	TCHAR	BASED_CODE	szServiceList[] = _T("EditSend;RTD;TTS;TtsKiwi;XE");
	/*	EditSend֌W	*/
	p->lpEdsGetProfile( lpszFile, lpszProfileEditSendSection );
	/*	ݒ֌W	*/
	p->bShiftLock = GetPrivateProfileInt( lpszProfileConfigSection, lpszProfileShiftLock, p->bShiftLock, lpszFile );
	p->bRtdDde = GetPrivateProfileInt( lpszProfileConfigSection, lpszProfileRtdDde, p->bRtdDde, lpszFile );
	GetPrivateProfileString( lpszProfileConfigSection, lpszProfileDdeServer,  szDefaultServer, p->szServerName, _MAX_FNAME, lpszFile );
	GetPrivateProfileString( lpszProfileConfigSection, lpszProfileDdeList,  szServiceList, p->szServiceList, _MAX_PATH, lpszFile );
	p->bSendAll = GetPrivateProfileInt( lpszProfileConfigSection, lpszProfileSendAll, p->bSendAll, lpszFile );
#ifdef	WIN32
	p->bRichEdit = GetPrivateProfileInt( lpszProfileConfigSection, lpszProfileRichEdit, p->bRichEdit, lpszFile );
	p->bNextRichEdit = p->bRichEdit;
	p->bBalloonTip = GetPrivateProfileInt( lpszProfileConfigSection, lpszProfileBalloonTip, FALSE, lpszFile );
#endif
	p->bClearAll = GetPrivateProfileInt( lpszProfileConfigSection, lpszProfileClearAll, p->bClearAll, lpszFile );
	/*	tHg	*/
	p->lfText.lfHeight = GetPrivateProfileInt( lpszProfileFontSection, lpszProfileHeightEntry, p->lfText.lfHeight, lpszFile );
	p->lfText.lfWeight = GetPrivateProfileInt( lpszProfileFontSection, lpszProfileWeightEntry, p->lfText.lfWeight, lpszFile );
	p->lfText.lfItalic = GetPrivateProfileInt( lpszProfileFontSection, lpszProfileItalicEntry, p->lfText.lfItalic, lpszFile );
	p->lfText.lfUnderline = GetPrivateProfileInt( lpszProfileFontSection, lpszProfileUnderlineEntry, p->lfText.lfUnderline, lpszFile );
	p->lfText.lfCharSet = GetPrivateProfileInt( lpszProfileFontSection, lpszProfileCharSetEntry, p->lfText.lfCharSet, lpszFile );
	p->lfText.lfPitchAndFamily = GetPrivateProfileInt( lpszProfileFontSection, lpszProfilePitchAndFamilyEntry, p->lfText.lfPitchAndFamily, lpszFile );
	GetPrivateProfileString( lpszProfileFontSection, lpszProfileFaceNameEntry, p->lfText.lfFaceName, p->lfText.lfFaceName, LF_FACESIZE, lpszFile );
	p->lfText.lfWidth = 0;
}


BOOL	NEAR	WritePrivateProfileInt( LPCTSTR lpszSection, LPCTSTR lpszKey, DWORD dwValue, LPCTSTR lpszFile )
{
	TCHAR	buff[256];
	static	const	TCHAR	BASED_CODE	szFmt[] = _T("%ld");
	wsprintf( buff, szFmt, dwValue );
	return WritePrivateProfileString( lpszSection, lpszKey, buff, lpszFile );
}

/*	INIt@Cւ̏	*/
void	NEAR	WriteProfile( NpEdLineInfo p, LPCTSTR lpszFile )
{
	static	const	TCHAR	BASED_CODE	szVersion[] = VERSION;
	/*	o[W	*/
	WritePrivateProfileString( lpszProfileSection, lpszProfileEntry, szVersion, lpszFile );
	/*	EditSend֌W	*/
	p->lpEdsWriteProfile( lpszFile, lpszProfileEditSendSection );
	/*	ݒ֌W	*/
	WritePrivateProfileInt( lpszProfileConfigSection, lpszProfileShiftLock, p->bShiftLock, lpszFile );
	WritePrivateProfileInt( lpszProfileConfigSection, lpszProfileRtdDde, p->bRtdDde, lpszFile );
	WritePrivateProfileString( lpszProfileConfigSection, lpszProfileDdeServer,  p->szServerName, lpszFile );
	WritePrivateProfileInt( lpszProfileConfigSection, lpszProfileSendAll, p->bSendAll, lpszFile );
#ifdef	WIN32
	WritePrivateProfileInt( lpszProfileConfigSection, lpszProfileRichEdit, p->bNextRichEdit, lpszFile );
#endif
	WritePrivateProfileInt( lpszProfileConfigSection, lpszProfileClearAll, p->bClearAll, lpszFile );
	/*	tHg	*/
	WritePrivateProfileInt( lpszProfileFontSection, lpszProfileHeightEntry, p->lfText.lfHeight, lpszFile );
	WritePrivateProfileInt( lpszProfileFontSection, lpszProfileWeightEntry, p->lfText.lfWeight, lpszFile );
	WritePrivateProfileInt( lpszProfileFontSection, lpszProfileItalicEntry, p->lfText.lfItalic, lpszFile );
	WritePrivateProfileInt( lpszProfileFontSection, lpszProfileUnderlineEntry, p->lfText.lfUnderline, lpszFile );
	WritePrivateProfileInt( lpszProfileFontSection, lpszProfileCharSetEntry, p->lfText.lfCharSet, lpszFile );
	WritePrivateProfileInt( lpszProfileFontSection, lpszProfilePitchAndFamilyEntry, p->lfText.lfPitchAndFamily, lpszFile );
	WritePrivateProfileString( lpszProfileFontSection, lpszProfileFaceNameEntry, p->lfText.lfFaceName, lpszFile );
	/*	tbV	*/
	WritePrivateProfileString( NULL,NULL, NULL, lpszFile );
}

/*	EditSend.dll̃[h	*/
static	BOOL	NEAR	LoadEditSendDll( HWND hWnd, NpEdLineInfo p )
{
	static	const	TCHAR	BASED_CODE	szDllName[] = _T("EditSend.dll");
	static	const	TCHAR	BASED_CODE	szEdsInitWindow[] =       _T("EdsInitWindow");
	static	const	TCHAR	BASED_CODE	szEdsInitWindowDialog[] = _T("EdsInitWindowDialog");
	static	const	TCHAR	BASED_CODE	szEdsInitParamDialog[] =  _T("EdsInitParamDialog");
	static	const	TCHAR	BASED_CODE	szEdsGetParam[] =         _T("EdsGetParam");
	static	const	TCHAR	BASED_CODE	szEdsGetDefaultParam[] =  _T("EdsGetDefaultParam");
	static	const	TCHAR	BASED_CODE	szEdsSendString[] =       _T("EdsSendString");
	static	const	TCHAR	BASED_CODE	szEdsWriteProfile[] =     _T("EdsWriteProfile");
	static	const	TCHAR	BASED_CODE	szEdsGetProfile[] =       _T("EdsGetProfile");
	
	/*	DLL[h	*/
	p->hInstDll = LoadLibrary( szDllName );
#ifdef	WIN32
	if( p->hInstDll == NULL ) {
#else
	if( p->hInstDll < HINSTANCE_ERROR ) {
#endif
		TCHAR	buff[256];
		LoadString( p->hInstance, IDS_ERR_NO_DLL, buff, 255 );
#ifdef	_DEBUG
		wsprintf( buff+lstrlen(buff), _T("\nG[:%d"), (int)p->hInstDll );
#endif
		MessageBox( hWnd, buff, p->szAppname, MB_APPLMODAL|MB_DEFBUTTON1|MB_ICONEXCLAMATION|MB_OK );
		return FALSE;
	}
	/*	API֐̃AhX擾	*/
	p->lpEdsInitWindow =       (LP_FUNC_EDSINITWINDOW)      GetProcAddress( p->hInstDll, szEdsInitWindow );
	p->lpEdsInitWindowDialog = (LP_FUNC_EDSINITWINDOWDIALOG)GetProcAddress( p->hInstDll, szEdsInitWindowDialog );
	p->lpEdsInitParamDialog =  (LP_FUNC_EDSINITPARAMDIALOG) GetProcAddress( p->hInstDll, szEdsInitParamDialog );
	p->lpEdsGetParam =         (LP_FUNC_EDSGETPARAM)        GetProcAddress( p->hInstDll, szEdsGetParam );
	p->lpEdsGetDefaultParam =  (LP_FUNC_EDSGETDEFAULTPARAM) GetProcAddress( p->hInstDll, szEdsGetDefaultParam );
	p->lpEdsSendString =       (LP_FUNC_EDSSENDSTRING)      GetProcAddress( p->hInstDll, szEdsSendString );
	p->lpEdsWriteProfile =     (LP_FUNC_EDSWRITEPROFILE)    GetProcAddress( p->hInstDll, szEdsWriteProfile );
	p->lpEdsGetProfile =       (LP_FUNC_EDSGETPROFILE)      GetProcAddress( p->hInstDll, szEdsGetProfile );
	if( p->lpEdsInitWindow == NULL || p->lpEdsInitWindowDialog == NULL || p->lpEdsInitParamDialog == NULL || p->lpEdsGetParam == NULL ||
		p->lpEdsGetDefaultParam == NULL || p->lpEdsSendString == NULL || p->lpEdsWriteProfile == NULL || p->lpEdsGetProfile == NULL ) {
		TCHAR	buff[256];
		FreeLibrary( p->hInstDll );
		p->hInstDll = NULL;
		LoadString( p->hInstance, IDS_ERR_BAD_DLL, buff, 255 );
		MessageBox( hWnd, buff, p->szAppname, MB_APPLMODAL|MB_DEFBUTTON1|MB_ICONEXCLAMATION|MB_OK );
		return FALSE;
	}
	p->EdsParam.dwStructSize = sizeof(p->EdsParam);
	p->lpEdsGetDefaultParam( &(p->EdsParam) );
	p->lpEdsInitWindow( p->hWndTarget );
	return TRUE;
}

/*	WM_CREATE	*/
LRESULT	NEAR	CreateProc( HWND hWnd, LPCREATESTRUCT pcs )
{
	NpEdLineInfo	p;
	HFONT	hFont, hSystemFont;
	WNDPROC		lpfnOldWndProc;
	static	const	TCHAR	BASED_CODE	szEditClassName[] = _T("EDIT");
	static	const	TCHAR	BASED_CODE	szButtonClassName[] = _T("BUTTON");
	static	const	TCHAR	BASED_CODE	szCaption[] = _T("");
#ifdef	WIN32
	static	const	TCHAR	BASED_CODE	szLibrayName[] = _T("RICHED32.DLL");
	static	const	TCHAR	BASED_CODE	szRichEditClass[] = _T("RICHEDIT");
	LPCTSTR	lpszClassName = szEditClassName;
#endif
	
	SetEdLineInfo( hWnd, NULL );
	p = (NpEdLineInfo)LocalAlloc( LPTR, sizeof(EdLineInfo) );
	if( p == NULL ) {
		return -1L;
	}
	p->hInstance = pcs->hInstance;
	
	{
		TCHAR	buff[_MAX_PATH];
		LPSTR	q, r, s;
		static	const	TCHAR	BASED_CODE	szExtension[] = _T(".ini");
		GetModuleFileName( p->hInstance, buff, _MAX_PATH );
		q = r = s = buff;
		while( *r != _T('\0') ) {
#if ( WINVER >= 0x030a )
			if( IsDBCSLeadByte( *r ) ) {
#else
			if( iskanji( *r ) && iskanji2( *(r+1) ) ) {
#endif
				r++;
			} else if( *r == _T('.') ) {
				s = r;	//	Ō'.'w
			} else if( *r == _T('\\') ) {
				q = r;	//	Ō'\\'w
			}
			r++;
		}
#ifdef	WIN32
		{
			WIN32_FIND_DATA	wfd;
			HANDLE	h;
			ZeroMemory( &wfd, sizeof(wfd) );
			h = FindFirstFile( buff, &wfd );
			if( h != INVALID_HANDLE_VALUE ) {
				FindClose( h );
				/*	t@Cǉ	*/
				*(q+1) = _T('\0');
				lstrcat( buff, wfd.cFileName );
				s = r = q;
				while( *r != _T('\0') ) {
					if( IsDBCSLeadByte( *r ) ) {
						r++;
					} else if( *r == _T('.') ) {
						s = r;	//	Ō'.'w
					}
					r++;
				}
			}
		}
#endif
#if ( WINVER >= 0x030a )
		lstrcpyn( p->szAppname, q+1, s-q );		//	{s-(q+1)ƎvǁEEE
#else
		strncpy( p->szAppname, q+1, s-(q+1) );
#endif
		*(p->szAppname+(s-(q+1))) = _T('\0');
		/*	INIt@C	*/
		lstrcpy( p->szProfile, buff );
		p->szProfile[ s-buff ] = _T('\0');
		lstrcat( p->szProfile, szExtension );
	}
	SetWindowText( hWnd, p->szAppname );
	
	/*	Mpobt@	*/
	p->dwSendBuffSize = 1024;
	p->hSendBuff = GlobalAlloc( GPTR, p->dwSendBuffSize );
	if( p->hSendBuff == NULL ) {
		LocalFree( (HLOCAL)p );
		return -1L;
	}
	
	/*	DDE֌W	*/
	p->hWndServer = NULL;
	p->nClientStatus = DDE_STAT_NONE;
	
	/*	EditSend.dll̃[h	*/
	if( !LoadEditSendDll( hWnd, p ) ) {
		GlobalFree( p->hSendBuff );
		LocalFree( (HLOCAL)p );
		PostMessage( hWnd, WM_CLOSE, 0, 0 );
		return -1L;
	}
	
	/*	ACR	*/
	p->hIcon = LoadIcon( p->hInstance, MAKEINTRESOURCE( IDI_ICON_EDLINE ) );
#ifdef	WIN32
	SendMessage( hWnd, WM_SETICON, ICON_BIG, (LPARAM)p->hIcon );
	{
		HICON	hIcon = (HICON)LoadImage( p->hInstance, MAKEINTRESOURCE(IDI_ICON_EDLINE), IMAGE_ICON, 16, 16, 0 );
		SendMessage( hWnd, WM_SETICON, ICON_SMALL, (LPARAM)hIcon );
	}
#endif
	
	/*	tHg	*/
	hSystemFont = GetStockObject( SYSTEM_FONT );
	if( hSystemFont == NULL ) {
		FreeLibrary( p->hInstDll );
		p->hInstDll = NULL;
		GlobalFree( p->hSendBuff );
		LocalFree( (HLOCAL)p );
		PostMessage( hWnd, WM_CLOSE, 0, 0 );
		return -1L;
	}
	hFont = (HFONT)SendMessage( hWnd, WM_GETFONT, 0, 0 );
	if( hFont == NULL ) {
		hFont = hSystemFont;
	}
	GetObject( hFont, sizeof(LOGFONT), &(p->lfText) );
	
	p->nHeight = 100;
	p->bShiftLock = FALSE;
	p->bRtdDde = FALSE;
	p->bSendAll = FALSE;
#ifdef	WIN32
	p->bRichEdit = p->bNextRichEdit = FALSE;
	p->hInstRichEdit = NULL;
#endif
	p->bClearAll = FALSE;
	p->hAccelClearAll = LoadAccelerators( p->hInstance, MAKEINTRESOURCE( IDR_ACCEL_CLEARALL ) );
	SetEdLineInfo( hWnd, p );
	
	/*	INIt@Cǂݍ	*/
	ReadProfile( p, p->szProfile );
	p->lpEdsGetParam( &(p->EdsParam) );
	
	/*	ҏWs	*/
#ifdef	WIN32
	if( p->bRichEdit ) {
		if( p->hInstRichEdit == NULL ) {
			p->hInstRichEdit = LoadLibrary( szLibrayName );
		}
		if( p->hInstRichEdit != NULL ) {
			lpszClassName = szRichEditClass;
		} else {
			p->bRichEdit = p->bNextRichEdit = FALSE;
		}
	}
	p->hWndEdit = CreateWindowEx( WS_EX_CLIENTEDGE, lpszClassName, szCaption,
						WS_CHILD|WS_VISIBLE|WS_TABSTOP|ES_AUTOHSCROLL,
#else
	p->hWndEdit = CreateWindowEx( 0, szEditClassName, szCaption,
						WS_CHILD|WS_VISIBLE|WS_TABSTOP|ES_AUTOHSCROLL|WS_BORDER,
#endif
						10, 10, 200, 40,
						hWnd, (HMENU)IDC_EDIT_TEXT, p->hInstance, NULL );
	
	/*	ݒ{^	*/
	p->hWndButton = CreateWindowEx( 0, szButtonClassName, szCaption,
						WS_CHILD|WS_VISIBLE|WS_TABSTOP|BS_PUSHBUTTON,
						250, 10, SPACE*4, 30,
						hWnd, (HMENU)IDC_BUTTON_SETTING, p->hInstance, NULL );
	
	/*	GfBbgRg[TuNX	*/
	lpfnOldWndProc = (WNDPROC)SetWindowLong( p->hWndEdit, GWL_WNDPROC, (LONG)EditWndProc );
	p->lpfnOldWndProc = lpfnOldWndProc;
	/*	tHg쐬	*/
	p->hFont = CreateFontIndirect( &(p->lfText) );
	SendMessage( p->hWndEdit, WM_SETFONT, (WPARAM)p->hFont, TRUE );
	/*	EBhETCYČvZ	*/
	RecalcLayout( hWnd );
	
	/*	|bvAbvj[	*/
	p->hMenuPopup = LoadMenu( p->hInstance, MAKEINTRESOURCE( IDR_MENU_POPUP ) );
	{	/*	VXej[ɒǉ	*/
		HMENU	hSysMenu = GetSystemMenu( hWnd, FALSE );
		HMENU	hSubMenu = GetSubMenu( p->hMenuPopup, 0 );
		if( hSysMenu != NULL && p->hMenuPopup != NULL ) {
			int		i, n;
			UINT	nID;
			TCHAR	buff[80];
			/*	Zp[^	*/
			AppendMenu( hSysMenu, MF_ENABLED|MF_SEPARATOR, 0, NULL );
			n = GetMenuItemCount( hSubMenu );
			for( i = 0; i < n; i++ ) {
				nID = GetMenuItemID( hSubMenu, i );
				if( nID != ID_APP_EXIT ) {
					GetMenuString( hSubMenu, i, buff, 80, MF_BYPOSITION );
					AppendMenu( hSysMenu, MF_ENABLED|MF_STRING, nID, buff );
				}
			}
		}
	}
	
#ifdef	WIN32
	/*	c[`bv	*/
	InitCommonControls();
	p->bMultilineTip = FALSE;
	{
		DWORD	dwFileMS, dwProdMS;
		if( GetDllVersion( _T("COMCTL32.DLL"), &dwFileMS, NULL, &dwProdMS, NULL ) ) {
			if( dwFileMS >= MAKELONG( 70, 4 ) && dwProdMS >= MAKELONG( 70, 4 ) ) {
				/*	COMCTL32.DLL4.70(IE3)ȍ~ȂOK	*/
				p->bMultilineTip = TRUE;
			}
			if( p->bBalloonTip ) {
				p->bBalloonTip = ( dwFileMS >= MAKELONG( 80, 5 ) && dwProdMS >= MAKELONG( 0, 5 ) );
				/*	COMCTL32.DLL5.80(IE5)ȍ~ȂOK	*/
			}
		}
	}
	{
		TooltipInfo	ti[] = {
			{ IDC_BUTTON_SETTING, IDS_TIPS_BUTTON_SETTING },
			{ IDC_EDIT_TEXT,      IDS_TIPS_EDIT_TEXT      },
			{ 0,                  IDS_TIPS_CLIENT         },
		};
		int		nCnt = sizeof(ti) / sizeof(TooltipInfo);
		p->hWndTooltip = CreateTooltip( hWnd, ti, nCnt, p->bMultilineTip, p->bBalloonTip, FALSE );
	}
#endif
	
	return 0L;
}

/*	WM_GETMINMAXINFO	*/
LRESULT	NEAR	GetMinMaxInfoProc( HWND hWnd, MINMAXINFO FAR* lpmmi )
{
	NpEdLineInfo	p = GetEdLineInfo( hWnd );
	if( p != NULL ) {
		/*	炩ߍ͌܂Ă	*/
		lpmmi->ptMinTrackSize.y = lpmmi->ptMaxTrackSize.y = (int)p->nHeight;
		/*	ŏ̓VXeKl	*/
		lpmmi->ptMinTrackSize.x = GetSystemMetrics( SM_CXMINTRACK );
	}
	return 0;
}


/*	WM_NCHITTEST	*/
LRESULT	NEAR	NcHitTestProc( HWND hWnd, LRESULT lResult )
{
	/*	㉺̃TCYύX͋֎~	*/
	switch( lResult ) {
	case HTBOTTOM:
	case HTTOP:
		return HTBORDER;
	case HTBOTTOMLEFT:
	case HTTOPLEFT:
		return HTLEFT;
	case HTBOTTOMRIGHT:
	case HTTOPRIGHT:
		return HTRIGHT;
	}
	return lResult;
}

#ifndef	ICON_APPLICATION
/*	WM_PAINT	*/
BOOL	NEAR	PaintProc( HWND hWnd )
{
	if( IsIconic( hWnd ) ) {
		NpEdLineInfo	p = GetEdLineInfo( hWnd );
		PAINTSTRUCT		ps;
		HDC		hDC;
		int		cxIcon, cyIcon, x, y;
		RECT	rect;
		
		hDC = BeginPaint( hWnd, &ps );
		SendMessage( hWnd, WM_ICONERASEBKGND, (WPARAM)hDC, 0 );
		
		/*	NCAg̋`̈̒ɃACR`	*/
		cxIcon = GetSystemMetrics( SM_CXICON );
		cyIcon = GetSystemMetrics( SM_CYICON );
		GetClientRect( hWnd, &rect );
		x = ( rect.right - rect.left - cxIcon + 1 ) / 2;
		y = ( rect.bottom - rect.top - cyIcon + 1 ) / 2;
		DrawIcon( hDC, x, y, p->hIcon );
		EndPaint( hWnd, &ps );
		return TRUE;
		/*
			95ƃ^XNo[ɓ邩A֌WȂ͂B
		*/
	}
	return FALSE;
}

/*	WM_QUERYDRAGICON	*/
HANDLE	NEAR	QueryDragIcon( HWND hWnd )
{
	NpEdLineInfo	p = GetEdLineInfo( hWnd );
	return p->hIcon;
	/*
		ACR̃hbOɁAACR`̂߂ɌĂ΂B
		(炵B95Ɩ֌WȂ͂)
	*/
}
#endif

/*	WM_INITMENUPOPUP	*/
BOOL	NEAR	InitMenuPopup( HWND hWnd, HMENU hMenuPopup, UINT uPos, BOOL fSystemMenu )
{
#ifndef	WIN32
	long	style = GetWindowLong( hWnd, GWL_STYLE );
	BOOL	bTitleBar = ( ( style & WS_BORDER ) != 0 );
	BOOL	bIconic = IsIconic( hWnd );
	if( fSystemMenu && !bTitleBar ) {	/*	^Cgo[	*/
		EnableMenuItem( hMenuPopup, SC_RESTORE,  MF_BYCOMMAND|!bIconic?MF_GRAYED:MF_ENABLED );
//		EnableMenuItem( hMenuPopup, SC_MOVE,     MF_BYCOMMAND| bIconic?MF_GRAYED:MF_ENABLED );
//		EnableMenuItem( hMenuPopup, SC_MOVE,     MF_BYCOMMAND|MF_ENABLED );
		EnableMenuItem( hMenuPopup, SC_SIZE,     MF_BYCOMMAND| bIconic?MF_GRAYED:MF_ENABLED );
		EnableMenuItem( hMenuPopup, SC_MINIMIZE, MF_BYCOMMAND| bIconic?MF_GRAYED:MF_ENABLED );
		EnableMenuItem( hMenuPopup, SC_MAXIMIZE, MF_BYCOMMAND|MF_GRAYED );
		EnableMenuItem( hMenuPopup, SC_CLOSE,    MF_BYCOMMAND|MF_ENABLED );
		/*
			SC_MOVÉA16bitł̓ACRԂłLB
			32bitł̓ACRԂł͖B
			Ȃ̂ŁAȂƂɂB
		*/
		return TRUE;
	}
#endif
	return FALSE;
}

/*	WM_LBUTTONDOWN	*/
BOOL	NEAR	LeftButtonDownProc( HWND hWnd, UINT fwKeys, WORD xPos, WORD yPos )
{
	NpEdLineInfo	p = GetEdLineInfo( hWnd );
	p->ptDrag.x = (short)xPos;
	p->ptDrag.y = (short)yPos;
	ClientToScreen( hWnd, &p->ptDrag );
	SetCapture( hWnd );
	return TRUE;
}

/*	WM_MOUSEMOVE	*/
BOOL	NEAR	MouseMoveProc( HWND hWnd, UINT fwKeys, WORD xPos, WORD yPos )
{
	NpEdLineInfo	p;
	POINT	point;
	int		xofs, yofs;
	if( GetCapture() != hWnd ) {
		return FALSE;
	}
	p = GetEdLineInfo( hWnd );
	point.x = (short)xPos;
	point.y = (short)yPos;
	ClientToScreen( hWnd, &point );
	xofs = point.x - p->ptDrag.x;
	yofs = point.y - p->ptDrag.y;
	if( xofs != 0 || yofs != 0 ) {
		RECT	rect;
		GetWindowRect( hWnd, &rect );
		OffsetRect( &rect, xofs, yofs );
		MoveWindow( hWnd, rect.left, rect.top, rect.right-rect.left, rect.bottom-rect.top, TRUE );
	}
	p->ptDrag = point;
	return TRUE;
}

/*	WM_LBUTTONUP	*/
BOOL	NEAR	LeftButtonUpProc( HWND hWnd, UINT fwKeys, WORD xPos, WORD yPos )
{
	if( !MouseMoveProc( hWnd, fwKeys, xPos, yPos ) ) {
		return FALSE;
	}
	ReleaseCapture();
	return TRUE;
}

/*	WM_RBUTTONUP	*/
BOOL	NEAR	RightButtonUpProc( HWND hWnd, UINT fwKeys, WORD xPos, WORD yPos )
{
	NpEdLineInfo	p = GetEdLineInfo( hWnd );
	POINT	pt;
	if( p == NULL || p->hMenuPopup == NULL ) {
		return FALSE;
	}
	if( IsIconic( hWnd ) ) {
		return FALSE;
	}
	pt.x = (short)xPos;
	pt.y = (short)yPos;
	if( pt.x < 0 || pt.y < 0 ) {
		return FALSE;
	} else {
#ifdef	WIN32
		UINT	flag = TPM_LEFTALIGN|TPM_RIGHTBUTTON;
#else
		UINT	flag = TPM_LEFTBUTTON;
#if ( WINVER >= 0x030a )
		UINT	uVersion = LOWORD( GetVersion() );
		if( ( (LOBYTE(uVersion)<<8) | HIBYTE(uVersion) ) >= 0x030a ) {
			flag = TPM_LEFTALIGN|TPM_RIGHTBUTTON;
		}
#endif
#endif
		ClientToScreen( hWnd, &pt );
		TrackPopupMenu( GetSubMenu( p->hMenuPopup, 0 ), flag, pt.x, pt.y, 0, hWnd, NULL );
	}
	return TRUE;
}

/*	WM_ACTIVATE	*/
BOOL	NEAR	ActivateProc( HWND hWnd, WORD fActive, BOOL fMinimized, HWND hWndActive )
{
	NpEdLineInfo	p = GetEdLineInfo( hWnd );
	if( fActive == WA_INACTIVE && p != NULL ) {
		/*	ݒ{^ɕtĂ(Ȃ)BS_DEFPUSHBUTTONO	*/
		long	style;
		style = GetWindowLong( p->hWndButton, GWL_STYLE );
		style &= ~BS_DEFPUSHBUTTON;
		SendMessage( p->hWndButton, BM_SETSTYLE, (WPARAM)LOWORD(style), TRUE );
	}
	return FALSE;
}

/*	WM_SYSCOMMAND	*/
BOOL	NEAR	SysCommandProc( HWND hWnd, UINT uCmdType, int xPos, int yPos )
{
	UINT	nCmd = 0;
	uCmdType &= 0xfff0;
	switch( uCmdType ) {
	case ID_APP_CONFIG:
		nCmd = ID_APP_CONFIG;
		break;
	case ID_APP_ABOUT:
		nCmd = ID_APP_ABOUT;
		break;
	}
	if( nCmd != 0 ) {
#ifdef	WIN32
		PostMessage( hWnd, WM_COMMAND, MAKEWPARAM( nCmd, 0 ), 0 );
#else
		PostMessage( hWnd, WM_COMMAND, nCmd, MAKELPARAM( 0, 0 ) );
#endif
	}
	return 0L;
}

/*	WM_COMMAND	*/
BOOL	NEAR	CommandProc( HWND hWnd, WORD wNotifyCode, WORD wID, HWND hwndCtl )
{
	NpEdLineInfo	p = GetEdLineInfo( hWnd );
	if( wID == IDC_BUTTON_SETTING || wID == ID_APP_CONFIG ) {	/*	ݒ	*/
		ConfigDlgInfo	Param;
		Param.hWndOwner = hWnd;
		DialogBoxParam( p->hInstance, MAKEINTRESOURCE( IDD_CONFIG_DIALOG ), hWnd, ConfigDlgProc, (LPARAM)&Param );
		RecalcLayout( hWnd );
		TerminateDDE( hWnd );
		if( p->bRtdDde ) {
			InitiateDDE( hWnd );
		}
		return TRUE;
	} else if( wID == ID_APP_ABOUT ) {		/*	o[W	*/
		TCHAR	buff[ 256 ], msg[ 256 ];
		static	const	TCHAR	BASED_CODE	szVersion[] = VERSION;
		LoadString( p->hInstance, IDS_VERSION, buff, 255 );
		wsprintf( msg, buff, (LPCTSTR)p->szAppname, (LPCTSTR)szVersion );
		MessageBox( hWnd, msg, p->szAppname, MB_APPLMODAL|MB_DEFBUTTON1|MB_ICONINFORMATION|MB_OK );
	} else if( wID == ID_APP_EXIT ) {		/*	I	*/
		PostMessage( hWnd, WM_CLOSE, 0, 0 );
	} else if( wID == ID_APP_CLEARALL ) {	/*	ESCőSď	*/
		if( p->hWndEdit != NULL && p->bClearAll ) {
#ifdef	WIN32
			SendMessage( p->hWndEdit, EM_SETSEL, (WPARAM)0, (LPARAM)(-1) );		/*	SI	*/
#else
			SendMessage( p->hWndEdit, EM_SETSEL, (WPARAM)0, MAKELPARAM(0,-1) );	/*	SI	*/
#endif
			SendMessage( p->hWndEdit, WM_CLEAR, (WPARAM)0, (LPARAM)0 );
		}
		return TRUE;
	}
	return FALSE;
}

/*	WM_DESTROY	*/
LRESULT	NEAR	DestroyProc( HWND hWnd )
{
	NpEdLineInfo	p = GetEdLineInfo( hWnd );
	
	if( p != NULL ) {
		/*	DDEI	*/
		TerminateDDE( hWnd );
		/*	GfBbgRg[̃TuNX	*/
		if( p->lpfnOldWndProc != NULL ) {
			SetWindowLong( p->hWndEdit, GWL_WNDPROC, (LONG)p->lpfnOldWndProc );
			p->lpfnOldWndProc = NULL;
		}
		/*	DLL	*/
#ifdef	WIN32
		if( p->hInstDll != NULL ) {
#else
		if( p->hInstDll >= HINSTANCE_ERROR ) {
#endif
			FreeLibrary( p->hInstDll );
			p->hInstDll = NULL;
		}
		/*	Mpobt@̉	*/
		if( p->hSendBuff != NULL ) {
			GlobalFree( p->hSendBuff );
		}
		/*	tHg폜	*/
		if( p->hFont != NULL ) {
			DeleteObject( p->hFont );
		}
#ifndef	WIN32
		/*	ACR̔j	*/
		if( p->hIcon != NULL ) {
			DestroyIcon( p->hIcon );
			p->hIcon = NULL;
		}
#endif
		/*	|bvAbvj[	*/
		if( p->hMenuPopup != NULL ) {
			DestroyMenu( p->hMenuPopup );
		}
		p->hMenuPopup = NULL;
#ifdef	WIN32
		if( p->hInstRichEdit != NULL ) {
			DestroyWindow( p->hWndEdit );
			FreeLibrary( p->hInstRichEdit );
			p->hInstRichEdit = NULL;
		}
#endif
#ifdef	WIN32
		if( p->hWndTooltip != NULL ) {
			/*	c[`bv폜	*/
			DestroyTooltip( p->hWndTooltip );
		}
#endif
		LocalFree( (HLOCAL)p );
		p = NULL;
		SetEdLineInfo( hWnd, p );
	}
	PostQuitMessage( 0 );
	return 0L;
}

/*	EBhEvV[W	*/
LRESULT	CALLBACK	EdLineWndProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	NpEdLineInfo	p = GetEdLineInfo( hWnd );
	switch( uMsg ) {
	case WM_CREATE:
		return CreateProc( hWnd, (LPCREATESTRUCT)lParam );
	case WM_SETFOCUS:
		if( p != NULL && p->hWndEdit != NULL && IsWindow( p->hWndEdit ) ) {
			SetFocus( p->hWndEdit );
			return 0L;
		}
		break;
	case WM_GETMINMAXINFO:
		return GetMinMaxInfoProc( hWnd, (MINMAXINFO FAR*)lParam );
	case WM_NCHITTEST:
		return NcHitTestProc( hWnd, DefWindowProc( hWnd, uMsg, wParam, lParam ) );
	case WM_WININICHANGE:
#ifdef	WIN32
		if( p != NULL && p->bRichEdit ) {
			SendMessage( p->hWndEdit, WM_SETFONT, (WPARAM)p->hFont, TRUE );
		}
		//	̂܂ܗ
#endif
	case WM_SIZE:
		RecalcLayout( hWnd );
		break;
#ifndef	ICON_APPLICATION
	case WM_PAINT:
		if( PaintProc( hWnd ) ) {
			return 0L;
		}
		break;
	case WM_QUERYDRAGICON:
#ifdef	WIN32
		return (LRESULT)QueryDragIcon( hWnd );
#else
		return MAKELRESULT( QueryDragIcon( hWnd ), 0 );
#endif
#endif
	case WM_INITMENUPOPUP:
		if( InitMenuPopup( hWnd, (HMENU)wParam, (UINT)LOWORD(lParam), (BOOL)HIWORD(lParam) ) ) {
			return 0L;
		}
		break;
	case WM_LBUTTONDOWN:
		if( LeftButtonDownProc( hWnd, (UINT)wParam, LOWORD(lParam), HIWORD(lParam) ) ) {
			return 0L;
		}
		break;
	case WM_MOUSEMOVE:
		if( MouseMoveProc( hWnd, (UINT)wParam, LOWORD(lParam), HIWORD(lParam) ) ) {
			return 0L;
		}
		break;
	case WM_LBUTTONUP:
		if( LeftButtonUpProc( hWnd, (UINT)wParam, LOWORD(lParam), HIWORD(lParam) ) ) {
			return 0L;
		}
		break;
	case WM_RBUTTONUP:
		if( RightButtonUpProc( hWnd, (UINT)wParam, LOWORD(lParam), HIWORD(lParam) ) ) {
			return 0L;
		}
		break;
	case WM_ACTIVATE:
#ifdef	WIN32
		if( ActivateProc( hWnd, LOWORD(wParam), (BOOL)HIWORD(wParam), (HWND)lParam ) ) {
#else
		if( ActivateProc( hWnd, wParam, (BOOL)HIWORD(lParam), (HWND)LOWORD(lParam) ) ) {
#endif
			return 0L;
		}
		break;
	case WM_SYSCOMMAND:
		if( SysCommandProc( hWnd, (UINT)wParam, LOWORD(lParam), HIWORD(lParam) ) ) {
			return 0L;
		}
		break;
	case WM_COMMAND:
#ifdef	WIN32
		if( CommandProc( hWnd, (WORD)HIWORD(wParam), LOWORD(wParam), (HWND)lParam ) ) {
#else
		if( CommandProc( hWnd, (WORD)HIWORD(lParam), wParam, (HWND)LOWORD(lParam) ) ) {
#endif
			return 0L;
		}
		break;
	case WM_DDE_ACK:
		if( DdeAckProc( hWnd, wParam, lParam ) ) {
			return 0L;
		}
		break;
	case WM_DDE_TERMINATE:
		if( DdeTerminateProc( hWnd, wParam, lParam ) ) {
			return 0L;
		}
		break;
	case WM_CLOSE:
		if( p != NULL ) {
			/*	INIt@Cɏ	*/
			WriteProfile( p, p->szProfile );
			WritePrivateProfileString( NULL, NULL,  NULL, p->szProfile );
			/*	^XNo[̋󔒂̃{^΍(?)	*/
			ShowWindow( hWnd, SW_HIDE );
		}
		break;
	case WM_DESTROY:
		return DestroyProc( hWnd );
	}
	return DefWindowProc( hWnd, uMsg, wParam, lParam );
}

/*	bZ[W̑O	*/
BOOL	NEAR	PreTranslateMessage( HWND hWnd, LPMSG lpmsg )
{
	NpEdLineInfo	p;
	if( hWnd == NULL ) {
		return TRUE;
	}
	p = GetEdLineInfo( hWnd );
#ifdef	WIN32
	if( p != NULL && p->hWndTooltip != NULL ) {
		RelayEventTooltip( p->hWndTooltip, lpmsg );
	}
#endif
	if( p != NULL && p->hWndEdit != NULL ) {
		if( p->hWndEdit == lpmsg->hwnd && p->hAccelClearAll != NULL ) {
			if( TranslateAccelerator( hWnd, p->hAccelClearAll, lpmsg ) ) {
				return TRUE;
			}
		}
		switch( lpmsg->message ) {
		case WM_KEYDOWN:
		case WM_KEYUP:
		case WM_CHAR:
			if( lpmsg->wParam == VK_ESCAPE ) {
				/*	EscapeIsDialogMessage()ɓnƏIĂ܂B	*/
				lpmsg->message = WM_NULL;
				return FALSE;
			} else if( lpmsg->wParam == VK_RETURN && p->hWndEdit == lpmsg->hwnd ) {
				/*	EditEnterIsDialogMessage()ɓnAOŏ	*/
				return FALSE;
			}
			break;
		}
	}
	return IsDialogMessage( hWnd, lpmsg );
}

/*	bZ[W̏	*/
void	DoMessage( HWND hWnd, LPMSG lpmsg )
{
	if( !PreTranslateMessage( hWnd, lpmsg ) ) {
		TranslateMessage( lpmsg );
		DispatchMessage( lpmsg );
	}
}

/*	C	*/
int		WINAPI	WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpszCmdLine, int nCmdShow )
{
	MSG		msg;
	HWND	hWnd;

	if( hPrevInstance == NULL ) {
		WNDCLASS	wc;
		wc.style = CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS;
		wc.lpfnWndProc = EdLineWndProc;
		wc.cbClsExtra = 0;
		wc.cbWndExtra = EDLINE_EXTRA_BYTES;
		wc.hInstance = hInstance;
		wc.hIcon = LoadIcon( hInstance, MAKEINTRESOURCE( IDI_ICON_EDLINE ) );
		wc.hCursor = LoadCursor( NULL, MAKEINTRESOURCE( IDC_ARROW ) );
#ifdef	WIN32
		wc.hbrBackground = (HBRUSH)( COLOR_BTNFACE+1 );
#else
		wc.hbrBackground = (HBRUSH)( COLOR_WINDOW+1 );
#endif
		wc.lpszMenuName = NULL;
		wc.lpszClassName = szEdLineWndClass;
		if( !RegisterClass( &wc ) ) {
			return FALSE;
		}
	}
	hWnd = CreateWindow( szEdLineWndClass, szEdLineAppName,
		WS_OVERLAPPED|WS_CAPTION|WS_SYSMENU|WS_MINIMIZEBOX|WS_THICKFRAME|WS_CLIPCHILDREN,
		CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
		NULL, NULL, hInstance, NULL );
	if( hWnd == NULL ) {
		return FALSE;
	}
#ifdef	WIN32
	ShowWindow( hWnd, SW_SHOWDEFAULT );	/*	lcc-win32΍B[A炵B	*/
#else
	ShowWindow( hWnd, nCmdShow );
#endif
	UpdateWindow( hWnd );

	while( GetMessage( &msg, NULL, 0, 0 ) ) {
		DoMessage( hWnd, &msg );
	}
	return (int)msg.wParam;
}
