/*--------------------------------------------------------------*\
		module	:	EdLinE.h
		purpose :	PsҏW
		author	:	_@ Kengo Jinno
		create	:	1998/11/11
		update	:	1999/03/02
					2001/02/07	EdLineInfo::szServiceListǉ
					2001/04/20	EdLineInfo::bSendAllǉ
					2001/04/20	EdLineInfo::bRichEdit, bNextRichEditǉ
					2001/04/20	EdLineInfo::hWndTooltip, bMultilineTipǉ
					2001/04/24	EdLineInfo::bBalloonTipǉ
					2014/04/04	EdLineInfo::bClearAllǉ
					2014/04/11	EdLineInfo::hAccelClearAllǉ
\*--------------------------------------------------------------*/

#ifndef	ED_LIN_E_H
#define	ED_LIN_E_H

#include	"EditSend.h"
#include	"resource.h"

typedef	struct	tagEdLineInfo	{
	HINSTANCE	hInstance;		/*	g̃CX^Xnh	*/
	LOGFONT		lfText;			/*	tHg		*/
	HFONT		hFont;			/*	tHg̃nh	*/
	HWND		hWndEdit;		/*	EDIT̃EBhEnh	*/
	HWND		hWndButton;		/*	BUTTOÑEBhEnh	*/
	LONG		nHeight;		/*	EBhE̍			*/
	POINT		ptDrag;			/*	hbÕ}EXW		*/
	BOOL		bShiftLock;		/*	VtgbN			*/
	BOOL		bRtdDde;		/*	RTDDDEg				*/
	BOOL		bSendAll;		/*	ׂđo					*/
#ifdef	WIN32
	BOOL		bRichEdit;		/*	RichEditg				*/
	BOOL		bNextRichEdit;	/*	񂩂RichEdit			*/
	HINSTANCE	hInstRichEdit;	/*	RICHED32.DLL				*/
#endif
	BOOL		bClearAll;		/*	ESCőSď				*/
	HACCEL		hAccelClearAll;	/*	̃ANZ[^			*/
#ifdef	WIN32
	HWND		hWndTooltip;	/*	c[`bv				*/
	BOOL		bMultilineTip;	/*	s̃c[`bv		*/
	BOOL		bBalloonTip;	/*	o[c[`bv		*/
#endif
	HGLOBAL		hSendBuff;		/*	Mpobt@				*/
	DWORD		dwSendBuffSize;	/*	Mpobt@̃TCY		*/
	HICON		hIcon;			/*	̃ACRnh		*/
	WNDPROC		lpfnOldWndProc;	/*	GfBbgRg[̋vV[W	*/
	TCHAR		szProfile[ _MAX_PATH ];		/*	INIt@C	*/
	TCHAR		szAppname[ _MAX_PATH ];		/*	Av		*/
	HMENU		hMenuPopup;		/*	|bvAbvj[	*/
	/*	DDE֌W	*/
	HWND		hWndServer;		/*	DDET[o[̃EBhEnh	*/
	int			nClientStatus;	/*	NCAg̏(}N)	*/
	TCHAR		szServerName[ _MAX_FNAME ];	/*	DDET[o[		*/
	TCHAR		szServiceList[ _MAX_PATH ];	/*	T[o[Xg	*/
	/*	EditSend.dll֌W	*/
	HWND		hWndTarget;		/*	M̃EBhEnh	*/
	HINSTANCE	hInstDll;		/*	DLL̃CX^Xnh	*/
	EdsParamType	EdsParam;	/*	EditSend̃p[^	*/
	LP_FUNC_EDSINITWINDOW		lpEdsInitWindow;
	LP_FUNC_EDSINITWINDOWDIALOG	lpEdsInitWindowDialog;
	LP_FUNC_EDSINITPARAMDIALOG	lpEdsInitParamDialog;
	LP_FUNC_EDSGETPARAM			lpEdsGetParam;
	LP_FUNC_EDSGETDEFAULTPARAM	lpEdsGetDefaultParam;
	LP_FUNC_EDSSENDSTRING		lpEdsSendString;
	LP_FUNC_EDSWRITEPROFILE		lpEdsWriteProfile;
	LP_FUNC_EDSGETPROFILE		lpEdsGetProfile;
}	EdLineInfo, NEAR* NpEdLineInfo;


#define	GWL_EDLINE_INFO	0

#ifdef	WIN32
#define	EDLINE_EXTRA_BYTES	sizeof(LONG)
#define	GetEdLineInfo(x)	( (NpEdLineInfo)GetWindowLong(x,GWL_EDLINE_INFO) )
#define	SetEdLineInfo(x,y)	SetWindowLong(x,GWL_EDLINE_INFO,(LONG)y)
#else
#define	EDLINE_EXTRA_BYTES	sizeof(WORD)
#define	GetEdLineInfo(x)	( (NpEdLineInfo)GetWindowWord(x,GWL_EDLINE_INFO) )
#define	SetEdLineInfo(x,y)	SetWindowWord(x,GWL_EDLINE_INFO,(WORD)y)
#endif

#define	IDC_BUTTON_SETTING	1000
#define	IDC_EDIT_TEXT		1001

extern	void	DoMessage( HWND hWnd, LPMSG lpmsg );

#define	CR		0x0d
#define	LF		0x0a

#ifndef	WIN32
#define	ZeroMemory(x,y)			memset((x),0,(int)(y))
#define	MoveMemory(x,y,z)		memmove((x),(y),(z))
#define	CopyMemory(x,y,z)		memcpy((x),(y),(z))
#endif

#endif	/*	ED_LIN_E_H	*/
